program test;

{$mode delphi}

uses
  sysutils, dynlibs;

type
  tfunc = function: pansichar;

function test_func(hnd: thandle; const prefix, name: string): string;
var
  func: pointer;
begin
  func := getprocedureaddress(hnd, name);
  if assigned(func) then
    result := concat(prefix, tfunc(func))
  else
    result := concat(prefix, name, ' failed');
end;

var
  liba, libb: thandle;
begin
  liba := loadlibrary('../liba/liba.so');
  if liba = nilhandle then
    halt(1);
  libb := loadlibrary('../libb/libb.so');
  if liba = nilhandle then
  begin
    unloadlibrary(liba);
    halt(2);
  end;
  writeln(output, test_func(liba, '', 'liba_test'));
  setcurrentdir('../libb');
  writeln(output, test_func(liba, 'a.dep: ', 'liba_dep'));
  writeln(output, test_func(libb, '', 'libb_test'));
  setcurrentdir('../liba');
  writeln(output, test_func(libb, 'b.dep: ', 'libb_dep'));
  unloadlibrary(liba);
  unloadlibrary(libb);
end.
